'use strict';Object.defineProperty(exports,'__esModule',{value:!0});function _interopDefault(a){return a&&'object'==typeof a&&'default'in a?a['default']:a}var queueUtil=require('@nx-js/queue-util'),observerUtil=require('@nx-js/observer-util'),React=require('react'),React__default=_interopDefault(React),PropTypes=_interopDefault(require('prop-types')),emptyTokens=new Set([void 0,'','.']),notEmpty=function(a){return!emptyTokens.has(a)};function normalizePath(a,b){void 0===a&&(a='');for(var c,d=[],e=0,f=toPathArray(a);e<f.length;e+=1)c=f[e],'..'===c?b--:notEmpty(c)&&d.push(c);return{normalizedPath:d,depth:'/'===a[0]?0:b}}function toPathArray(a){return void 0===a&&(a=''),a.split('/').filter(notEmpty)}function toPathString(a){return void 0===a&&(a=[]),'/'+a.filter(notEmpty).join('/')}function toQuery(a){void 0===a&&(a={});var b=[];for(var c in a){var d=a[c];notEmpty(d)&&(c=encodeURIComponent(c),d=encodeURIComponent(JSON.stringify(d)),b.push(c+'='+d))}return b.length?'?'+b.join('&'):''}function toParams(a){void 0===a&&(a='');for(var b=a.slice(1).split('&').filter(notEmpty),c={},d=0,e=b;d<e.length;d+=1){var f=e[d],g=f.split('='),h=decodeURIComponent(g[0]),j=JSON.parse(decodeURIComponent(g[1]));c[h]=j}return c}function toHash(a){return void 0===a&&(a={}),a.anchor?'#'+a.anchor:''}function toScroll(a){return a?{anchor:a.slice(1)}:void 0}function toUrl(a){var b=a.path,c=a.params,d=a.scroll;return toPathString(b)+toQuery(c)+toHash(d)}function toObject(a){var b=a.indexOf('?');b=-1===b?1/0:b;var c=a.indexOf('#');return c=-1===c?1/0:c,{path:toPathArray(a.slice(0,b)),params:toParams(a.slice(b,c)),scroll:toScroll(a.slice(c))}}function addExtraProps(a,b,c){for(var d in b)d in c||(a[d]=b[d]);return a}var state=new queueUtil.Queue(queueUtil.priorities.SYNC),integrations=new queueUtil.Queue(queueUtil.priorities.LOW);function stop(){state.stop(),integrations.stop()}function start(){state.start(),integrations.start()}function process(){state.process(),integrations.process()}var routingStatus,routers=[],initStatuses=new Set;function registerRouter(a,b){routers[b]||(routers[b]=new Set),routers[b].add(a),(!routingStatus||b<=routingStatus.depth)&&initRouter(a,b)}function initRouter(a,b){var c={depth:b,cancelled:!1};return initStatuses.add(c),Promise.resolve().then(function(){return a.startRouting()}).then(function(b){return!c.cancelled&&a.finishRouting(b)}).then(function(){return initStatuses.delete(c)})}function releaseRouter(a,b){routers[b].delete(a)}function route(a){routeFromDepth(a,0)}function routeFromDepth(a,b){void 0===a&&(a={});var c=a.to;void 0===c&&(c=toPathString(path));var d=a.params;void 0===d&&(d={});var e=a.scroll,f=a.push,g=a.inherit;void 0===b&&(b=0);var h=normalizePath(c,b),i=h.depth,j=h.normalizedPath;b=i,initStatuses.forEach(function(a){return a.cancelled=b<=a.depth}),routingStatus?routingStatus.cancelled=!0:integrations.process(),stop();var k=routingStatus={depth:b,cancelled:!1},l=Array.from(path);return path.splice.apply(path,[b,1/0].concat(j)),g||Object.keys(params).forEach(function(a){return delete params[a]}),Object.assign(params,d),Promise.resolve().then(function(){return switchRoutersFromDepth(b,k)}).then(function(){return finishRouting({scroll:e,push:f,prevPath:l},k)})}function switchRoutersFromDepth(a,b){var c=Array.from(routers[a]||[]);if(c.length)return Promise.resolve().then(function(){return startRoutingAtDepth(c,b)}).then(function(a){return finishRoutingAtDepth(c,a,b)}).then(function(){return switchRoutersFromDepth(++a,b)})}function startRoutingAtDepth(a,b){if(!b.cancelled)return Promise.all(a.map(function(a){return a.startRouting()}))}function finishRoutingAtDepth(a,b,c){if(!c.cancelled)return Promise.all(a.map(function(a,c){return a.finishRouting(b[c])}))}function finishRouting(a,b){var c=a.scroll,d=a.push,e=a.prevPath;if(!b.cancelled){var f=toPathString(path)!==toPathString(e);(!0===d||!1!==d&&f)&&history.push({path:path,params:params,scroll:c}),'object'==typeof c?scroller.scrollTo(c):f&&scroller.scrollTo({top:0,left:0}),process(),start(),routingStatus=void 0}}var elements={anchor:'a',div:'div'},scroller={scrollTo:function(){}},animation={setup:function(){},enter:function(){},leave:function(){}},storage=observerUtil.observable({}),params=observerUtil.observable({}),path=observerUtil.observable([]),items=[],idx=0,history={createItem:function(a){return void 0===a&&(a={}),'string'==typeof a&&(a=toObject(a)),a={path:Array.from(a.path),params:Object.assign({},a.params),scroll:a.scroll,url:toUrl(a)},Object.assign(params,a.params),path.splice.apply(path,[0,1/0].concat(a.path)),a},get state(){return items[idx]},get length(){return items.length},push:function(a){items.splice(++idx,1/0,this.createItem(a))},replace:function(a){items[idx]=this.createItem(a)},go:function(a){idx=Math.min(items.length-1,Math.max(0,idx+a));var b=items[idx],c=b.path,d=b.params,e=b.scroll;return route({to:toPathString(c),params:d,scroll:e,push:!1})},back:function(){this.go(-1)},forward:function(){this.go(1)}};function syncHistory(){var a=history.state?history.state.scroll:void 0;history.replace({path:path,params:params,scroll:a})}observerUtil.observe(syncHistory,{scheduler:integrations}),Object.defineProperties(history,{state:{get:function(){return window.history.state}},length:{get:function(){return window.history.length}}}),Object.assign(history,{push:function(a){a=history.createItem(a),window.history.pushState(a,'',a.url)},replace:function(a){a=history.createItem(a),window.history.replaceState(a,'',a.url)},go:function(a){return window.history.go(a)},forward:function(){return window.history.forward()},back:function(){return window.history.back()}}),window.addEventListener('popstate',function(a){var b=a.state,c=b.path,d=b.params,e=b.scroll;return route({to:toPathString(c),params:d,scroll:e,push:!1})}),window.history.scrollRestoration='manual',Object.assign(scroller,{scrollTo:function(a){if(a.anchor){var b=document.getElementById(a.anchor);b&&(b.scrollIntoView(a),window.scrollBy(a))}else window.scrollTo(a)}});var scroll=toScroll(location.hash);if('object'==typeof scroll){function a(){if(scroller.scrollTo(scroll),scroll.anchor){var b=document.getElementById(scroll.anchor),c=Date.now()-start$1<RETRY_TIMEOUT;!b&&c&&setTimeout(a,RETRY_INTERVAL)}}var RETRY_INTERVAL=100,RETRY_TIMEOUT=5e3,start$1=Date.now();a()}var FROM_DOM=Symbol('from DOM'),TO_DOM=Symbol('to DOM');Object.assign(animation,{setup:function(a){this.cleanup(a),a[FROM_DOM]=a.firstElementChild},enter:function(a,b){var c=a[TO_DOM]=a.firstElementChild;if(b&&c)return b(c)},leave:function(a,b){var c=this,d=a[FROM_DOM],e=a[TO_DOM]=a.firstElementChild;if(b&&d)return d===e&&(d=a[FROM_DOM]=d.cloneNode(!0)),a.insertBefore(d,e),Promise.resolve().then(function(){return b(d)}).then(function(){return c.cleanup(a)})},cleanup:function(a){a[FROM_DOM]&&a[FROM_DOM]!==a[TO_DOM]&&a[FROM_DOM].remove(),a[FROM_DOM]=a[TO_DOM]=void 0}}),Object.assign(params,toParams(location.search)),path.push.apply(path,toPathArray(location.pathname)),history.replace({path:path,params:params,scroll:toScroll(location.hash)});var STORAGE_NAME='REACT_EASY_STORAGE';Object.assign(storage,JSON.parse(localStorage.getItem('REACT_EASY_STORAGE')));function syncStorage(){localStorage.setItem(STORAGE_NAME,JSON.stringify(storage))}observerUtil.observe(syncStorage,{scheduler:integrations});var COMPONENT=Symbol('owner component'),DUMMY_STATE={};function view(a,b){void 0===b&&(b={});var c=b.devtool,d=!(a.prototype&&a.prototype.isReactComponent),e=d?React.Component:a,f=c?function(b){return c(Object.assign({Component:a},b))}:void 0,g=function(b){function c(a,c){var d=this;b.call(this,a,c),this.state=this.state||{},this.state[COMPONENT]=this;var e=function(){return d.setState(DUMMY_STATE)};this.render=observerUtil.observe(this.render,{scheduler:{add:function(){return state.add(e)},delete:function(){return state.delete(e)}},debugger:f,lazy:!0})}return b&&(c.__proto__=b),c.prototype=Object.create(b&&b.prototype),c.prototype.constructor=c,c.prototype.render=function(){return d?a(this.props,this.context):b.prototype.render.call(this)},c.prototype.shouldComponentUpdate=function(a,c){var d=this,e=d.props,g=d.state;if(b.prototype.shouldComponentUpdate&&!b.prototype.shouldComponentUpdate.call(this,a,c))return f&&f({type:'render',renderType:'blocked'}),!1;if(g!==c)return f&&f({type:'render',renderType:'reactive'}),!0;var h=Object.keys(e),i=Object.keys(a);return!!(i.length!==h.length||i.some(function(b){return e[b]!==a[b]}))&&(f&&f({type:'render',renderType:'normal',props:a,oldProps:e}),!0)},c.getDerivedStateFromProps=function(a,c){if(b.deriveStoresFromProps){var d=mapStateToStores(c);b.deriveStoresFromProps.apply(this,[a].concat(d))}return b.getDerivedStateFromProps?b.getDerivedStateFromProps.call(this,a,c):null},c.prototype.componentWillUnmount=function(){b.prototype.componentWillUnmount&&b.prototype.componentWillUnmount.call(this),observerUtil.unobserve(this.render)},c}(e);return g.displayName=a.displayName||a.name,d&&Object.assign(g,a),g}function mapStateToStores(a){var b=a[COMPONENT];return Object.keys(b).map(function(a){return b[a]}).filter(observerUtil.isObservable).map(observerUtil.raw)}var Router=function(a){function b(){for(var b=this,c=[],d=arguments.length;d--;)c[d]=arguments[d];var e;return e=a.apply(this,c),this.state={},this.saveContainer=function(a){return b.container=a},e}a&&(b.__proto__=a),b.prototype=Object.create(a&&a.prototype),b.prototype.constructor=b;var c={depth:{configurable:!0}};return b.prototype.getChildContext=function(){return{easyRouterDepth:this.depth+1}},c.depth.get=function(){return this.context.easyRouterDepth||0},b.prototype.componentDidMount=function(){registerRouter(this,this.depth)},b.prototype.componentWillUnmount=function(){releaseRouter(this,this.depth)},b.prototype.route=function(a){routeFromDepth(a,this.depth)},b.prototype.startRouting=function(){var a=this.props,b=a.onRoute,c=this.state.page,d=path[this.depth]||this.props.defaultPage;if(path[this.depth]=d,b)return b({target:this,fromPage:c,toPage:d,fromParams:history.state.params})},b.prototype.finishRouting=function(a){var b=this,c=this.state.page,d=path[this.depth],e=this.props,f=e.enterAnimation,g=e.leaveAnimation,h=this.props.shouldAnimate;'function'==typeof h&&(h=h({fromPage:c,toPage:d})),void 0===h&&(h=c!==d),h&&this.container&&animation.setup(this.container);var i={resolvedData:a,page:d};return new Promise(function(a){return b.setState(i,a)}).then(function(){h&&b.container&&(f&&b.inited&&animation.enter(b.container,f),g&&animation.leave(b.container,g)),b.inited=!0})},b.prototype.render=function(){var a=this.props,c=a.element,d=this.state,e=d.page,f=d.resolvedData,g=null;return React__default.isValidElement(f)?(validateChild(f),g=f):(g=this.selectChild(e),g&&f&&(g=React__default.cloneElement(g,f))),React__default.createElement(c,addExtraProps({ref:this.saveContainer},this.props,b.propTypes),g)},b.prototype.selectChild=function(a){var b=React.Children.toArray(this.props.children);b.forEach(validateChild);var c=b.find(function(b){return b.props.page===a});if(!c&&this.container){var d=this.props,e=d.notFoundPage;return b.find(function(a){return a.props.page===e})}return c},Object.defineProperties(b.prototype,c),b}(React.PureComponent);Router.propTypes={defaultPage:PropTypes.string.isRequired,notFoundPage:PropTypes.string,onRoute:PropTypes.func,enterAnimation:PropTypes.func,leaveAnimation:PropTypes.func,shouldAnimate:PropTypes.oneOfType([PropTypes.bool,PropTypes.func]),element:PropTypes.oneOfType([PropTypes.string,PropTypes.func])},Router.defaultProps={element:elements.div},Router.childContextTypes={easyRouterDepth:PropTypes.number},Router.contextTypes={easyRouterDepth:PropTypes.number};function validateChild(a){if('string'!=typeof a.props.page)throw new Error('Every Router child must have a string valued page prop')}var Link=function(a){function b(){for(var b=this,c=[],d=arguments.length;d--;)c[d]=arguments[d];var e;return e=a.apply(this,c),this.state={},this.onClick=function(a){var c=b.props,d=c.to,e=c.params,f=c.scroll,g=c.push,h=c.inherit,i=c.onClick;routeFromDepth({to:d,params:e,scroll:f,push:g,inherit:h},b.depth),a.preventDefault(),i&&i(a)},e}a&&(b.__proto__=a),b.prototype=Object.create(a&&a.prototype),b.prototype.constructor=b;var c={depth:{configurable:!0},absolutePath:{configurable:!0}};return c.depth.get=function(){var a=this.props,b=a.to,c=this.context.easyRouterDepth||0,d=!b||'/'!==b[0];return d?c:0},c.absolutePath.get=function(){var a=normalizePath(this.props.to,this.depth),b=a.depth,c=a.normalizedPath;return path.slice(0,b).concat(c)},b.prototype.componentDidMount=function(){var a=this;this.activityUpdater=observerUtil.observe(function(){return a.setState({isActive:a.isLinkActive()})},{scheduler:state})},b.prototype.componentWillUnmount=function(){observerUtil.unobserve(this.activityUpdater)},b.prototype.isLinkActive=function(){var a=this.props,b=a.activeClass,c=a.activeStyle,d=a.isActive,e=a.params,f=a.scroll;if(b||c)return d?d({path:this.absolutePath,params:e,scroll:f}):this.isLinkPathActive()&&this.isLinkParamsActive()&&this.isLinkScrollActive()},b.prototype.isLinkPathActive=function(){return this.absolutePath.every(function(a,b){return a===path[b]})},b.prototype.isLinkParamsActive=function(){var a=this.props.params;if(a){var b=Object.keys(a);return b.every(function(b){return a[b]===params[b]})}return!0},b.prototype.isLinkScrollActive=function(){var a=this.props.scroll,b=history.state.scroll;return!(a&&b)||a.anchor===b.anchor},b.prototype.render=function(){var a=this.props,c=a.to,d=a.params,e=a.scroll,f=a.element,g=a.children,h=a.activeClass,i=a.activeStyle,j=a.style,k=a.className,l=this.state,m=l.isActive,n=this,o=n.onClick,p=toUrl({path:this.absolutePath,params:d,scroll:e});return m&&(k=k+' '+h,j=Object.assign({},j,i)),React__default.createElement(f,addExtraProps({href:p,onClick:o,className:k,style:j},this.props,b.propTypes),g)},Object.defineProperties(b.prototype,c),b}(React.PureComponent);Link.propTypes={to:PropTypes.string,params:PropTypes.object,scroll:PropTypes.object,push:PropTypes.bool,inherit:PropTypes.bool,onClick:PropTypes.func,className:PropTypes.string,style:PropTypes.object,activeClass:PropTypes.string,activeStyle:PropTypes.object,isActive:PropTypes.func,element:PropTypes.oneOfType([PropTypes.string,PropTypes.func])},Link.defaultProps={element:elements.anchor,className:'',activeClass:'',style:{},activeStyle:{}},Link.contextTypes={easyRouterDepth:PropTypes.number},exports.store=observerUtil.observable,exports.view=view,exports.Router=Router,exports.Link=Link,exports.route=route,exports.elements=elements,exports.scroller=scroller,exports.animation=animation,exports.storage=storage,exports.params=params,exports.path=path,exports.history=history;