'use strict';Object.defineProperty(exports,'__esModule',{value:!0});function _interopDefault(a){return a&&'object'==typeof a&&'default'in a?a['default']:a}var queueUtil=require('@nx-js/queue-util'),React=require('react'),React__default=_interopDefault(React),observerUtil=require('@nx-js/observer-util'),PropTypes=_interopDefault(require('prop-types'));const state=new queueUtil.Queue(queueUtil.priorities.SYNC),integrations=new queueUtil.Queue(queueUtil.priorities.LOW);function stop(){state.stop(),integrations.stop()}function start(){state.start(),integrations.start()}function process(){state.process(),integrations.process()}const COMPONENT=Symbol('owner component'),DUMMY_STATE={};function view(a,{devtool:b}={}){const c=!(a.prototype&&a.prototype.isReactComponent),d=c?React.Component:a,e=b?c=>b(Object.assign({Component:a},c)):void 0;class f extends d{constructor(a,b){super(a,b),this.state=this.state||{},this.state[COMPONENT]=this;const c=()=>this.setState(DUMMY_STATE);this.render=observerUtil.observe(this.render,{scheduler:{add:()=>state.add(c),delete:()=>state.delete(c)},debugger:e,lazy:!0})}render(){return c?a(this.props,this.context):super.render()}shouldComponentUpdate(a,b){const{props:c,state:d}=this;if(super.shouldComponentUpdate&&!super.shouldComponentUpdate(a,b))return e&&e({type:'render',renderType:'blocked'}),!1;if(d!==b)return e&&e({type:'render',renderType:'reactive'}),!0;const f=Object.keys(c),g=Object.keys(a);return!!(g.length!==f.length||g.some(b=>c[b]!==a[b]))&&(e&&e({type:'render',renderType:'normal',props:a,oldProps:c}),!0)}static getDerivedStateFromProps(a,b){if(super.deriveStoresFromProps){const c=mapStateToStores(b);super.deriveStoresFromProps(a,...c)}return super.getDerivedStateFromProps?super.getDerivedStateFromProps(a,b):null}componentWillUnmount(){super.componentWillUnmount&&super.componentWillUnmount(),observerUtil.unobserve(this.render)}}return f.displayName=a.displayName||a.name,c&&Object.assign(f,a),f}function mapStateToStores(a){const b=a[COMPONENT];return Object.keys(b).map(a=>b[a]).filter(observerUtil.isObservable).map(observerUtil.raw)}const emptyTokens=new Set([void 0,'','.']),notEmpty=a=>!emptyTokens.has(a);function normalizePath(a='',b){const c=[];for(let d of toPathArray(a))'..'===d?b--:notEmpty(d)&&c.push(d);return{normalizedPath:c,depth:'/'===a[0]?0:b}}function toPathArray(a=''){return a.split('/').filter(notEmpty)}function toPathString(a=[]){return'/'+a.filter(notEmpty).join('/')}function toQuery(a={}){const b=[];for(let c in a){let d=a[c];notEmpty(d)&&(c=encodeURIComponent(c),d=encodeURIComponent(JSON.stringify(d)),b.push(`${c}=${d}`))}return b.length?`?${b.join('&')}`:''}function toParams(a=''){const b=a.slice(1).split('&').filter(notEmpty),c={};for(let d of b){const a=d.split('='),b=decodeURIComponent(a[0]),e=JSON.parse(decodeURIComponent(a[1]));c[b]=e}return c}function toHash(a={}){return a.anchor?`#${a.anchor}`:''}function toScroll(a){return a?{anchor:a.slice(1)}:void 0}function toUrl({path:a,params:b,scroll:c}){return toPathString(a)+toQuery(b)+toHash(c)}function toObject(a){let b=a.indexOf('?');b=-1===b?1/0:b;let c=a.indexOf('#');return c=-1===c?1/0:c,{path:toPathArray(a.slice(0,b)),params:toParams(a.slice(b,c)),scroll:toScroll(a.slice(c))}}function addExtraProps(a,b,c){for(let d in b)d in c||(a[d]=b[d]);return a}const routers=[];let routingStatus;const initStatuses=new Set;function registerRouter(a,b){routers[b]||(routers[b]=new Set),routers[b].add(a),(!routingStatus||b<=routingStatus.depth)&&initRouter(a,b)}function initRouter(a,b){const c={depth:b,cancelled:!1};return initStatuses.add(c),Promise.resolve().then(()=>a.startRouting()).then(b=>!c.cancelled&&a.finishRouting(b)).then(()=>initStatuses.delete(c))}function releaseRouter(a,b){routers[b].delete(a)}function route(a){routeFromDepth(a,0)}function routeFromDepth({to:d=toPathString(path),params:e={},scroll:a,push:b,inherit:c}={},f=0){const{depth:g,normalizedPath:h}=normalizePath(d,f);f=g,initStatuses.forEach(a=>a.cancelled=f<=a.depth),routingStatus?routingStatus.cancelled=!0:integrations.process(),stop();const i=routingStatus={depth:f,cancelled:!1},j=Array.from(path);return path.splice(f,1/0,...h),c||Object.keys(params).forEach(a=>delete params[a]),Object.assign(params,e),Promise.resolve().then(()=>switchRoutersFromDepth(f,i)).then(()=>finishRouting({scroll:a,push:b,prevPath:j},i))}function switchRoutersFromDepth(a,b){const c=Array.from(routers[a]||[]);if(c.length)return Promise.resolve().then(()=>startRoutingAtDepth(c,b)).then(a=>finishRoutingAtDepth(c,a,b)).then(()=>switchRoutersFromDepth(++a,b))}function startRoutingAtDepth(a,b){if(!b.cancelled)return Promise.all(a.map(a=>a.startRouting()))}function finishRoutingAtDepth(a,b,c){if(!c.cancelled)return Promise.all(a.map((a,c)=>a.finishRouting(b[c])))}function finishRouting({scroll:a,push:b,prevPath:c},d){if(!d.cancelled){const d=toPathString(path)!==toPathString(c);(!0===b||!1!==b&&d)&&history.push({path,params,scroll:a}),process(),start(),routingStatus=void 0}}const elements={anchor:'a',div:'div'},scroller={scrollTo(){}},animation={setup(){},enter(){},leave(){}},storage=observerUtil.observable({}),params=observerUtil.observable({}),path=observerUtil.observable([]),items=[];let idx=0;const history={createItem(a={}){return'string'==typeof a&&(a=toObject(a)),a={path:Array.from(a.path),params:Object.assign({},a.params),scroll:a.scroll,url:toUrl(a)},Object.assign(params,a.params),path.splice(0,1/0,...a.path),a},get state(){return items[idx]},get length(){return items.length},push(a){items.splice(++idx,1/0,this.createItem(a))},replace(a){items[idx]=this.createItem(a)},go(a){idx=Math.min(items.length-1,Math.max(0,idx+a));const{path:b,params:c,scroll:d}=items[idx];return route({to:toPathString(b),params:c,scroll:d,push:!1})},back(){this.go(-1)},forward(){this.go(1)}};function syncHistory(){const a=history.state?history.state.scroll:void 0;history.replace({path,params,scroll:a})}observerUtil.observe(syncHistory,{scheduler:integrations});class Router extends React.PureComponent{constructor(...a){var b;return b=super(...a),this.state={},this.saveContainer=a=>this.container=a,b}getChildContext(){return{easyRouterDepth:this.depth+1}}get depth(){return this.context.easyRouterDepth||0}componentDidMount(){registerRouter(this,this.depth)}componentWillUnmount(){releaseRouter(this,this.depth)}route(a){routeFromDepth(a,this.depth)}startRouting(){const{onRoute:a}=this.props,b=this.state.page,c=path[this.depth]||this.props.defaultPage;if(path[this.depth]=c,a)return a({target:this,fromPage:b,toPage:c,fromParams:history.state.params})}finishRouting(a){const b=this.state.page,c=path[this.depth],{enterAnimation:d,leaveAnimation:e}=this.props;let f=this.props.shouldAnimate;'function'==typeof f&&(f=f({fromPage:b,toPage:c})),f===void 0&&(f=b!==c),f&&this.container&&animation.setup(this.container);const g={resolvedData:a,page:c};return new Promise(a=>this.setState(g,a)).then(()=>{f&&this.container&&(d&&this.inited&&animation.enter(this.container,d),e&&animation.leave(this.container,e)),this.inited=!0})}render(){const{element:a}=this.props,{page:b,resolvedData:c}=this.state;let d=null;return React__default.isValidElement(c)?(validateChild(c),d=c):(d=this.selectChild(b),d&&c&&(d=React__default.cloneElement(d,c))),React__default.createElement(a,addExtraProps({ref:this.saveContainer},this.props,Router.propTypes),d)}selectChild(a){const b=React.Children.toArray(this.props.children);b.forEach(validateChild);const c=b.find(b=>b.props.page===a);if(!c&&this.container){const{notFoundPage:a}=this.props;return b.find(b=>b.props.page===a)}return c}}Router.propTypes={defaultPage:PropTypes.string.isRequired,notFoundPage:PropTypes.string,onRoute:PropTypes.func,enterAnimation:PropTypes.func,leaveAnimation:PropTypes.func,shouldAnimate:PropTypes.oneOfType([PropTypes.bool,PropTypes.func]),element:PropTypes.oneOfType([PropTypes.string,PropTypes.func])},Router.defaultProps={element:elements.div},Router.childContextTypes={easyRouterDepth:PropTypes.number},Router.contextTypes={easyRouterDepth:PropTypes.number};function validateChild(a){if('string'!=typeof a.props.page)throw new Error('Every Router child must have a string valued page prop')}class Link extends React.PureComponent{constructor(...a){var b;return b=super(...a),this.state={},this.onClick=a=>{const{to:b,params:c,scroll:d,push:e,inherit:f,onClick:g}=this.props;routeFromDepth({to:b,params:c,scroll:d,push:e,inherit:f},this.depth),a.preventDefault(),g&&g(a)},b}get depth(){const{to:a}=this.props,b=this.context.easyRouterDepth||0,c=!a||'/'!==a[0];return c?b:0}get absolutePath(){const{depth:a,normalizedPath:b}=normalizePath(this.props.to,this.depth);return path.slice(0,a).concat(b)}componentDidMount(){this.activityUpdater=observerUtil.observe(()=>this.setState({isActive:this.isLinkActive()}),{scheduler:state})}componentWillUnmount(){observerUtil.unobserve(this.activityUpdater)}isLinkActive(){const{activeClass:a,activeStyle:b,isActive:c,params:d,scroll:e}=this.props;if(a||b)return c?c({path:this.absolutePath,params:d,scroll:e}):this.isLinkPathActive()&&this.isLinkParamsActive()&&this.isLinkScrollActive()}isLinkPathActive(){return this.absolutePath.every((a,b)=>a===path[b])}isLinkParamsActive(){const a=this.props.params;if(a){const b=Object.keys(a);return b.every(b=>a[b]===params[b])}return!0}isLinkScrollActive(){const a=this.props.scroll,b=history.state.scroll;return!(a&&b)||a.anchor===b.anchor}render(){let{to:a,params:b,scroll:c,element:d,children:e,activeClass:f,activeStyle:g,style:h,className:i}=this.props;const{isActive:j}=this.state,{onClick:k}=this,l=toUrl({path:this.absolutePath,params:b,scroll:c});return j&&(i=`${i} ${f}`,h=Object.assign({},h,g)),React__default.createElement(d,addExtraProps({href:l,onClick:k,className:i,style:h},this.props,Link.propTypes),e)}}Link.propTypes={to:PropTypes.string,params:PropTypes.object,scroll:PropTypes.object,push:PropTypes.bool,inherit:PropTypes.bool,onClick:PropTypes.func,className:PropTypes.string,style:PropTypes.object,activeClass:PropTypes.string,activeStyle:PropTypes.object,isActive:PropTypes.func,element:PropTypes.oneOfType([PropTypes.string,PropTypes.func])},Link.defaultProps={element:elements.anchor,className:'',activeClass:'',style:{},activeStyle:{}},Link.contextTypes={easyRouterDepth:PropTypes.number},exports.store=observerUtil.observable,exports.view=view,exports.Router=Router,exports.Link=Link,exports.route=route,exports.elements=elements,exports.scroller=scroller,exports.animation=animation,exports.storage=storage,exports.params=params,exports.path=path,exports.history=history;